"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBabelPresetReactOpts = void 0;
const semver_1 = __importDefault(require("../../compiled/semver"));
function getBabelPresetReactOpts(pkg) {
    const reactVer = Object.assign({}, pkg.dependencies, pkg.peerDependencies).react;
    let opts = {};
    if (reactVer) {
        const isLTRReact17 = semver_1.default.ltr('17.0.0-0', reactVer);
        opts = {
            // use legacy jsx runtime for react@<17
            runtime: isLTRReact17 ? 'automatic' : 'classic',
            ...(isLTRReact17 ? {} : { importSource: undefined }),
        };
    }
    return opts;
}
exports.getBabelPresetReactOpts = getBabelPresetReactOpts;
