"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const process = __importStar(require("process"));
const yargs_parser_1 = __importDefault(require("../compiled/yargs-parser"));
const constants_1 = require("./constants");
const logger = __importStar(require("./logger"));
const service_1 = require("./services/service");
const engines_1 = require("./utils/engines");
async function run(opts = {}) {
    var _a;
    (0, engines_1.checkNodeVersion)();
    (0, engines_1.checkLocal)();
    (0, engines_1.setNodeTitle)();
    (0, engines_1.setNoDeprecation)();
    const args = (_a = opts.args) !== null && _a !== void 0 ? _a : (0, yargs_parser_1.default)(process.argv.slice(2), {
        alias: {
            version: ['v'],
            help: ['h'],
        },
        boolean: ['version'],
    });
    const command = args._[0];
    if ([constants_1.DEV_COMMAND, 'setup'].includes(command)) {
        process.env.NODE_ENV = 'development';
    }
    else if (command === 'build') {
        process.env.NODE_ENV = 'production';
    }
    try {
        const service = new service_1.Service({
            cwd: process.cwd(),
        });
        const name = args._[0];
        await service.runCommand({ name, args });
    }
    catch (e) {
        logger.fatal(e);
        process.exit(1);
    }
}
exports.run = run;
