import type { MsupConfig } from './types';
export declare function defineConfig(config: MsupConfig): MsupConfig;
declare type ISchema = Record<string, any>;
export declare function loadConfig(): Promise<MsupConfig>;
interface IOpts {
    cwd: string;
    specifiedEnv?: string;
    defaultConfigFiles?: string[];
}
export declare class Config {
    opts: IOpts;
    mainConfigFile: string | null;
    prevConfig: any;
    files: string[];
    constructor(opts: IOpts);
    getConfig(opts?: {
        schemas?: ISchema;
    }): {
        config: {};
        files: string[];
    };
    static getMainConfigFile(opts: {
        cwd: string;
        defaultConfigFiles?: string[];
    }): string | null;
    static getConfigFiles(opts: {
        mainConfigFile: string | null;
        specifiedEnv?: string;
    }): string[];
    getUserConfig(): {
        config: {};
        files: string[];
    };
    static getUserConfig(opts: {
        configFiles: string[];
    }): {
        config: {};
        files: string[];
    };
    static validateConfig(opts: {
        config: any;
        schemas: ISchema;
    }): void;
}
export {};
