import type { Command } from '../commands/command';
import { Config } from '../config/config';
import { PkgType } from '../types';
export declare function getPkg({ cwd }: {
    cwd: string;
}): {
    pkg: Record<string, string | Record<string, any>>;
    pkgPath: string;
};
interface ServiceOpts {
    cwd: string;
}
export declare class Service {
    opts: ServiceOpts;
    commands: Record<string, Command>;
    cwd: string;
    name?: string;
    config: Record<string, any>;
    userConfig: Record<string, any>;
    pkg: PkgType;
    pkgPath: string;
    configManager: Config | null;
    constructor(opts: ServiceOpts);
    runCommand(opts: {
        name: string;
        args?: any;
    }): Promise<void>;
    initLoaders(): Promise<void>;
}
export {};
