"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setNoDeprecation = exports.setNodeTitle = exports.checkLocal = exports.checkNodeVersion = void 0;
const constants_1 = require("../constants");
const logger = __importStar(require("../logger"));
const env_1 = require("./env");
function checkNodeVersion() {
    const v = parseInt(process.version.slice(1));
    if (v < constants_1.MIN_NODE_VERSION || v === 15 || v === 17) {
        logger.error(`Your node version ${v} is not supported, please upgrade to ${constants_1.MIN_NODE_VERSION} or above except 15 or 17.`);
        process.exit(1);
    }
}
exports.checkNodeVersion = checkNodeVersion;
function checkLocal() {
    if ((0, env_1.isLocalDev)()) {
        logger.info('@local');
    }
}
exports.checkLocal = checkLocal;
function setNodeTitle(name) {
    if (process.title === 'node') {
        process.title = name || constants_1.FRAMEWORK_NAME;
    }
}
exports.setNodeTitle = setNodeTitle;
function setNoDeprecation() {
    // Use magic to suppress node deprecation warnings
    // See: https://github.com/nodejs/node/blob/master/lib/internal/process/warning.js#L77
    // @ts-ignore
    process.noDeprecation = '1';
}
exports.setNoDeprecation = setNoDeprecation;
